; BETRIEB stellt die Betriebsart nach Bedienung ein

betrieb:
; Not-Aus?
    sbrc    tasten,notaus     
    rjmp    betrieb1
    cbi     portb,usb               ; Arduino-Box ausschalten
    jmp     handaus

betrieb1:
    sbrc    tasten,schalterHand
    rjmp    betrieb3                ; zur Handbedienung
; Handbetrieb ausschalten
    call    handaus
    cbi     portb,usb               ; Arduino-Box einschalten
; Stop-Taste?
    sbrs    tasten,tasteStop
    rjmp    betrieb2
    sbi     portb,usb
betrieb2:
    ret
    
; Handbedienung
betrieb3:
    sbi   portb,usb
	ldi		zl,low(bettab*2)
	ldi		zh,high(bettab*2)
	lds		acc,betsta
	call	sprung
	ijmp

bettab:
    .dw     bet0
    .dw     bet1
    .dw     bet2
    .dw     bet3
    .dw     bet4
    
; Joystick oder Referenzfahrten
; Referenzfahrt nach 0,0?
bet0:
    sbrs    tasten,tasteRef00           
    rjmp    bet0a
    cbr     tasten,(1<<tasteRef00)      ; Quittieren
    ldi     acc,1
    sts     betsta,acc
    ret
; Referenzfahrt nach hinten?
bet0a:
    sbrs    tasten,tasteNachHinten           
    rjmp    bet0b
    cbr     tasten,(1<<tasteNachHinten) ; Quittieren
    ldi     acc,3
    sts     betsta,acc
    ret
; Joystick
bet0b:
    call    joystick
    ret

; Referenzfahrt nach 0,0 starten
bet1:
    ldi     acc,drzhalt
    sts     neuedrzx,acc
    sts     neuedrzy,acc
    sts     neuedrzz,acc
    cbi     portb,usb               ; Arduino-Box ausschalten
    ldi     acc,1
    sts     refsta,acc
    jmp     betnext
; Referenzfahrt fertig oder Stop?
bet2:
    sbrs    tasten,tasteStop        ; soll stoppen?
    rjmp    bet2a
    ldi     acc,drzhalt
    sts     neuedrzx,acc
    sts     neuedrzy,acc
    sts     neuedrzz,acc
    clr     acc
    sts     refsta,acc 
    sts     betsta,acc
    ret
bet2a:
    lds     acc,refsta
    tst     acc
    breq    bet2b                   ; fertig?
    ret
bet2b:
    clr     acc                     ; beenden!
    sts     betsta,acc
    ret        
    
; Referenzfahrt nach hinten starten
bet3:
    ldi     acc,drzhalt
    sts     neuedrzx,acc
    sts     neuedrzy,acc
    sts     neuedrzz,acc
    cbi     portb,usb               ; Arduino-Box ausschalten
    ldi     acc,14
    sts     refsta,acc
    jmp     betnext
; Referenzfahrt fertig oder Stop?
bet4:
    sbrs    tasten,tasteStop        ; soll stoppen?
    rjmp    bet4a
    ldi     acc,drzhalt
    sts     neuedrzx,acc
    sts     neuedrzy,acc
    sts     neuedrzz,acc
    clr     acc
    sts     refsta,acc 
    sts     betsta,acc
    ret
bet4a:
    lds     acc,refsta
    tst     acc
    breq    bet4b                   ; fertig?
    ret
bet4b:
    clr     acc                     ; beenden!
    sts     betsta,acc
    ret
    
betnext:
    lds     acc,betsta
    inc     acc
    sts     betsta,acc
    ret        

; UPs
handaus:
    cbi     portd,dir_x
    cbi     portd,dir_y
    cbi     portd,dir_z
    ldi     acc,drzhalt
    sts     neuedrzx,acc
    sts     neuedrzy,acc
    sts     neuedrzz,acc
    sts     altedrzx,acc
    sts     altedrzy,acc
    sts     altedrzz,acc
    clr     acc
    sts     refsta,acc
    mov     sollzlrlx,acc
    mov     sollzlrhx,acc
    mov     sollzlrly,acc
    mov     sollzlrhy,acc
    mov     sollzlrlz,acc
    mov     sollzlrhz,acc
    ret
