; ---------------------------------------------------------------
; ram.inc Definition der Register und Datensegment
; ---------------------------------------------------------------
; 1.) Register, bitadressierbar mit sbrc,sbrs: r0 bis r15

.def    softtimer=r3
.def    sollzlrlx=r4
.def    sollzlrhx=r5
.def    sollzlrly=r6
.def    sollzlrhy=r7
.def    sollzlrlz=r8
.def    sollzlrhz=r9
.def    zlrlx=r20
.def    zlrhx=r11
.def    zlrly=r21
.def    zlrhy=r13
.def    zlrlz=r22
.def    zlrhz=r15

; -------------------------------------------------------------
; 2.) Register, bitadressierbar mit cbr,sbr,sbrc,sbrs,ser: r16 bis r31

.def	acc=r16
.def	acc2=r17
.def	acc3=r18
; Fr TIM0INT
.def	acc4=r19
; allgemeine bits
.def    merker=r23
; Eingnge
.def    tasten=r24 
.def    endschalter=r25


; 28,29=y 30,31=z

; -------------------------------------------------------------
; 3.) SRAM

	.dseg

; Timer
timintzsp:		.byte	1
reftim:         .byte   1

; Statuszhler
anasta:         .byte   1
refsta:         .byte   1
betsta:         .byte   1

; gemessene Analogwerte
pumpenpoti:     .byte   1
potix:          .byte   1
potiy:          .byte   1

; Eingnge entprellen
endschkopie:    .byte   1
endzlr:         .byte   1
tastenzsp:      .byte   1
etpzlr:         .byte   1

; Drehzahlen
neuedrzx:       .byte   1
altedrzx:       .byte   1
neuedrzy:       .byte   1
altedrzy:       .byte   1
neuedrzz:       .byte   1
altedrzz:       .byte   1


clrende:        .byte   1
