; REFCON steuert die beiden Refenzfahrten
; starten:
; nach 0,0: (D)refsta=1
; nach hinten: (D)refsta=14
; fertig wenn in (D)refsta=0

refcon:
    lds     acc,reftim
    tst     acc
    breq    refconV
    ret
refconV:
	ldi		zl,low(reftab*2)
	ldi		zh,high(reftab*2)
	lds		acc,refsta
	call	sprung
	ijmp

reftab:
	.dw		ref0
	.dw		ref1
	.dw		ref2
	.dw		ref3
	.dw		ref4
	.dw		ref5
	.dw		ref6
	.dw		ref7
	.dw		ref8
	.dw		ref9
	.dw		ref10
	.dw		ref11
	.dw		ref12
	.dw		ref13
	.dw		ref14
	.dw		ref15
	.dw		ref16
	.dw		ref17
	.dw		ref18
	.dw		ref19
	.dw		ref20
	.dw		ref21
	.dw		ref22

; Standby

ref0:
    ldi     acc,10
    sts     reftim,acc
    ret
    
; ----------------------------------------------------
; Referenzfahrt: nach 0,0
; ----------------------------------------------------
; 1.) Z nach oben zum Endschalter
ref1:
    ldi     acc,drzmaxpos
    sts     neuedrzz,acc
    ldi     acc,0
    jmp     refnext
; 2.) Endeschalter Z oben erreicht?   
ref2:
    sbrc    endschalter,endeZO
    ret
    ldi     acc,50              ; 500ms warten
    jmp     refnext
; 3.) mit minimaler Drehzahl den Endschalter Z verlassen
ref3:
    ldi     acc,drzminneg
    sts     neuedrzz,acc
    ldi     acc,0
    jmp     refnext
; 4.) Endschalter Z verlassen?
ref4:
    sbrs    endschalter,endeZO
    ret
    ldi     acc,drzhalt
    sts     neuedrzz,acc
    ldi     acc,30
    jmp     refnext
; 5.) Y nach vorne zum Endschalter
ref5:
    ldi     acc,drzmaxneg
    sts     neuedrzy,acc
    ldi     acc,0
    jmp     refnext
; 6.) Endeschalter Y vorne erreicht?   
ref6:
    sbrc    endschalter,endeYV
    ret
    ldi     acc,50
    jmp     refnext
; 7.) mit minimaler Drehzahl den Endschalter Y verlassen
ref7:
    ldi     acc,drzminpos
    sts     neuedrzy,acc
    ldi     acc,0
    jmp     refnext
; 8.) Endschalter Y verlassen?
ref8:
    sbrs    endschalter,endeYV
    ret
    ldi     acc,drzhalt
    sts     neuedrzy,acc
    ldi     acc,30              ; 300ms warten
    jmp     refnext
; 9.) X nach links zum Endschalter
ref9:
    ldi     acc,drzmaxneg
    sts     neuedrzx,acc
    ldi     acc,0
    jmp     refnext
; 10.) Endeschalter X links erreicht?   
ref10:
    sbrc    endschalter,endeXL
    ret
    ldi     acc,30              ; 300ms warten
    jmp     refnext
; 11.) mit minimaler Drehzahl den Endschalter X verlassen
ref11:
    ldi     acc,drzminpos
    sts     neuedrzx,acc
    ldi     acc,0
    jmp     refnext
; 12.) Endschalter X verlassen?
ref12:
    sbrs    endschalter,endeXL
    ret
    ldi     acc,drzhalt
    sts     neuedrzx,acc
    ldi     acc,1
    jmp     refnext
    
; 13.) fertig melden
ref13:
    clr     acc
    sts     refsta,acc
    ret    
    
; ----------------------------------------------------
; Das Portal nach hinten fahren
; ----------------------------------------------------
; 1.) Z nach oben zum Endschalter
ref14:
    ldi     acc,drzmaxpos
    sts     neuedrzz,acc
    ldi     acc,0
    jmp     refnext
; 2.) Endeschalter Z oben erreicht?   
ref15:
    sbrc    endschalter,endeZO
    ret
    ldi     acc,50
    jmp     refnext
; 3.) mit minimaler Drehzahl den Endschalter Z verlassen
ref16:
    ldi     acc,drzminneg
    sts     neuedrzz,acc
    ldi     acc,0
    jmp     refnext
; 4.) Endschalter Z verlassen?
ref17:
    sbrs    endschalter,endeZO
    ret
    ldi     acc,drzhalt
    sts     neuedrzz,acc
    ldi     acc,30              ; 300ms warten
    jmp     refnext
; 5.) Y nach hinten zum Endschalter
ref18:
    ldi     acc,drzmaxpos
    sts     neuedrzy,acc
    ldi     acc,0
    jmp     refnext
; 6.) Endeschalter Y hinten erreicht?   
ref19:
    sbrc    endschalter,endeYH
    ret
    ldi     acc,50
    jmp     refnext
; 7.) mit minimaler Drehzahl den Endschalter Y verlassen
ref20:
    ldi     acc,drzminneg
    sts     neuedrzy,acc
    ldi     acc,0
    jmp     refnext
; 8.) Endschalter Y verlassen?
ref21:
    sbrs    endschalter,endeYH
    ret
    ldi     acc,drzhalt
    sts     neuedrzy,acc
    ldi     acc,30              ; 300ms warten
    jmp     refnext
; 9.) Fertig melden
ref22:
    clr     acc
    sts     refsta,acc
    ret    

; -------------------------------------------------
; Ausgang

refnext:
    sts     reftim,acc          ; Timer setzen
    lds     acc,refsta
    inc     acc
    sts     refsta,acc
    ret