
;--------------------------------------------------
; AnaInput
;--------------------------------------------------
; anainput liet alle 3 Analogeingnge, 8 bit
; Ausgang: (D)pumpenpoti, (D)potix, (D)potiy

anainput:
	sbic	adcsra,adsc	; ADW fertig?
	ret					; nein
    
	ldi		zl,low(anatab*2)
	ldi		zh,high(anatab*2)
	lds		acc,AnaSta
	call	sprung
	ijmp

anatab:
	.dw		ana0
	.dw		ana1
	.dw		ana2
	.dw		ana3
	.dw		ana4
	.dw		ana5
	
	
; 1.) Mux auf Pumpenpoti setzen

ana0:
	ldi		acc,0b01100000
	out		admux,acc
	ldi		acc,0b11000111	; ADW starten
	out		adcsra,acc
	jmp		ananext
	
; 2.) Pumpenpoti lesen

ana1:
	in		acc,adcl
	in		acc,adch
  lsl   acc             ; Bereich verkleinern
	sts		pumpenpoti,acc
	jmp		ananext

; 3.) Mux auf Poti X setzen

ana2:
	ldi		acc,0b01100010
	out		admux,acc
	ldi		acc,0b11000111	; ADW starten
	out		adcsra,acc
	jmp		ananext

; 4.) Poti X lesen

ana3:
	in		acc,adcl
	in		acc,adch
	sts		potix,acc
	jmp		ananext

; 5.) Mux auf Poti Y setzen

ana4:
	ldi		acc,0b01100011
	out		admux,acc
	ldi		acc,0b11000111	; ADW starten
	out		adcsra,acc
	jmp		ananext
    
; 6.) Poti Y lesen

ana5:
	in		acc,adcl
	in		acc,adch
	sts		potiy,acc
	jmp		anareset

; Ausgnge	
	
ananext:
	lds		acc,anasta
	inc		acc
	sts		anasta,acc
	ret
	
anareset:
	ldi		acc,0
	sts		anasta,acc
	ret	
			
